
#define UL unsigned long int
#define TRYCOUNT	3

#include <stdio.h>
#include <windows.h>

#include "insert.cpp"
#include "replace(ipm)sortcore.cpp"

double replacetotal[10];
double inserttotal[10];
UL datacount[10];
UL triedcount;

void result()
{
	UL i;

		printf("data count insert        | replace\n");
	
	for(i=0;i<triedcount;i++)
	{
		printf(" %7d  %14.8f %14.8f\n"
		,datacount[i],inserttotal[i]/TRYCOUNT,replacetotal[i]/TRYCOUNT);
	}
	
	
}

UL CheckSort(UL *d,UL *e,UL count)
{
	//0 ... OK 1 ... NG
	UL i;
	for(i=0;i<(count-1);i++)
	{
		if ( (d[i]<d[i+1]) || ( (d[i]==d[i+1]) && (e[i]<e[i+1]) ) )
		{
		}else
		{
			return 1;
		}
		
	}
	return 0;
}

void MakeRandomize(UL *d,UL *e,UL count)
{
//
	UL i,sai;

	srand((unsigned)time(NULL));/* ǉ */

	for(i = 0; i < count; i++)
	{
		sai = rand() % RAND_MAX + 1;
		d[i]=sai;
		e[i]=i;
		if ( i % 10000 ==0 )
		{
//			printf("f[^Zbg %d\r",i);
		}
	}
	
}
void main()
{
	UL i,j,k;
	__int64 fr,t1,t2;
	double onetime;
	UL *d,*e;
	UL *od,*oe;
	
	
	for(i=0;i<10;i++)
	{
		datacount[i]=10000*(i+1);
//		printf("%d %d\n",i,datacount[i]);
	}
	
	triedcount=0;
	
	i=0;
	while ( 1 )
	{
		d=(UL*)malloc(datacount[i]*sizeof(UL));
		e=(UL*)malloc(datacount[i]*sizeof(UL));
		od=(UL*)malloc(datacount[i]*sizeof(UL));
		oe=(UL*)malloc(datacount[i]*sizeof(UL));
		
		printf("insert sort\n");
		
		inserttotal[i]=0.0;
		replacetotal[i]=0.0;
		
		MakeRandomize(od,oe,datacount[i]);
//		printf("randmize passed\n");
		
		//insert
		
		for(j=0;j<TRYCOUNT;j++)
		{
			for(k=0;k<datacount[i];k++)
			{
				d[k]=od[k];e[k]=oe[k];
//				if (k%1000==0)
//				printf("f[^ %d %d\r",k,datacount[i]);
			}
			QueryPerformanceFrequency((LARGE_INTEGER *)&fr);
			QueryPerformanceCounter((LARGE_INTEGER *)&t1);
			
			insertsort(d,e,datacount[i]);
			
			QueryPerformanceCounter((LARGE_INTEGER *)&t2);
			onetime=(double)(t2-t1) / fr * 1000;
		
			printf("%f ",onetime);
			
			if ( CheckSort(d,e,datacount[i])==1 )
			{
				MessageBoxA(NULL,"insert\[gɎs܂","info",MB_OK);
			}
			
			inserttotal[i]+=onetime;
		}
		printf("\n");

		//replace
		printf("replace sort\n");
		
		for(j=0;j<TRYCOUNT;j++)
		{
			for(k=0;k<datacount[i];k++)
			{
				d[k]=od[k];e[k]=oe[k];
//				if (k%1000==0)
//				printf("f[^ %d %d\r",k,datacount[i]);
			}
			QueryPerformanceFrequency((LARGE_INTEGER *)&fr);
			QueryPerformanceCounter((LARGE_INTEGER *)&t1);
			
			replacesorte(d,e,0,datacount[i]-1);
			
			QueryPerformanceCounter((LARGE_INTEGER *)&t2);
			onetime=(double)(t2-t1) / fr * 1000;
		
			printf("%f ",onetime);
			if ( CheckSort(d,e,datacount[i])==1 )
			{
				MessageBoxA(NULL,"replace\[gɎs܂","info",MB_OK);
			}
			replacetotal[i]+=onetime;
		}
		printf("\n");


		free(d);
		free(e);
		free(od);
		free(oe);
		
		triedcount++;
		result();
//		break;
//		printf("i:%f l:%f\n",inserttotal[i],replacetotal[i]);

		if ( replacetotal[i] > inserttotal[i] )
		{
			if ( (replacetotal[i] - inserttotal[i]) > 5*TRYCOUNT*1000 )
			{
				printf("õ\[gŁA5bȏ̍t܂\n");
				printf("PCł́Ainsert\[g̕ł\n");
				break;
			}
		}
		if ( inserttotal[i] > replacetotal[i]  )
		{
			if ( (inserttotal[i] - replacetotal[i]) > 5*TRYCOUNT*1000 )
			{
				printf("õ\[gŁA5bȏ̍t܂\n");
				printf("PCł́Areplace\[g̕ł\n");
				break;
			}
		}
		i++;
		if (i==10) break;

	}
	
	if (i>9)
	{
		if ( replacetotal[9] > inserttotal[9] )
		{
			printf("PCł́Ainsert\[g̕ł\n");
		}else
		{
			printf("PCł́Areplace\[g̕ł\n");
		}
	}
	
}
