/*
	programed by yakki 2014
	\[g
	O(N^2)
	
	gp@

	replacesort(d,l,r);
	d...f[^̔z
	l...\[gJnʒu(ʏ0)
	r...\[gIʒu(ʏ-1)

	replacesorte(d,e,l,r)
	d...f[^̔z
	e...z̗vf̔ԍ
	l...\[gJnʒu(ʏ0)
	r...\[gIʒu(ʏ-1)
	\[gɁAeɂ́A\[gO̗vfԍɂȂ
	
	vO //here ̉ӏ3̕stɂƁA
	A~؂ւ܂B
*/

#define UL unsigned long int

void swap(UL *d1,UL *d2);
void billiardRtoL(UL *d,UL left,UL right);
void billiardLtoR(UL *d,UL left,UL right);
void billiardRtoLe(UL *d,UL *e,UL left,UL right);
void billiardLtoRe(UL *d,UL *e,UL left,UL right);
void split(UL *d,UL dst,bool blright,UL *leftmoveto,UL *rightmoveto
,UL l,UL r,UL center);
void splite(UL *d,UL *e,UL dst,bool blright,UL *leftmoveto,UL *rightmoveto
,UL l,UL r,UL center);
void replacesort(UL *d,UL l,UL r);
void replacesorte(UL *d,UL *e,UL l,UL r);



void swap(UL *d1,UL *d2)
{
	UL t;
	t=*d1;*d1=*d2;*d2=t;return;
}

void billiardRtoL(UL *d,UL left,UL right)
{
/* 4 2 4 2 1
   ---->
       ---->
   1 2 4 2 4
*/
	UL i,temp;
	UL src,dest;
	
	dest=right;
	src=right-1;
	temp=d[right];
	
	while ( 1 )
	{
		if ( d[src]==d[left] || (src==left) )
		{
			d[dest]=d[src];dest=src;
		}
		if ( src==left ) break;
		src--;
	}
	d[left]=temp;
}
void billiardLtoR(UL *d,UL left,UL right)
{
/* 4 1 2 2 1
     <------
   <--
   1 1 2 2 4
*/
	UL i,temp;
	UL src,dest;
	
	dest=left;
	src=left+1;
	temp=d[left];
	
	while ( 1 )
	{
		if ( d[src]==d[right] || (src==right) )
		{
			d[dest]=d[src];dest=src;
		}
		if ( src==right ) break;
		src++;
	}
	d[right]=temp;
}


void billiardRtoLe(UL *d,UL *e,UL left,UL right)
{
/* 4 2 4 2 1
   ---->
       ---->
   1 2 4 2 4
*/
	UL i,temp,tempe;
	UL src,dest;
	
	dest=right;
	src=right-1;
	temp=d[right];tempe=e[right];
	
	while ( 1 )
	{
		if ( d[src]==d[left] || (src==left) )
		{
			d[dest]=d[src];e[dest]=e[src];dest=src;
		}
		if ( src==left ) break;
		src--;
	}
	d[left]=temp;
	e[left]=tempe;
}


void billiardLtoRe(UL *d,UL *e,UL left,UL right)
{
/* 4 1 2 2 1
     <------
   <--
   1 1 2 2 4
*/
	UL i,temp,tempe;
	UL src,dest;
	
	dest=left;
	src=left+1;
	temp=d[left];tempe=e[left];
	
	while ( 1 )
	{
		if ( d[src]==d[right] || (src==right) )
		{
			d[dest]=d[src];e[dest]=e[src];
			dest=src;
		}
		if ( src==right ) break;
		src++;
	}
	d[right]=temp;
	e[right]=tempe;
}

void split(UL *d,UL dst,bool blright,UL *leftmoveto,UL *rightmoveto
,UL l,UL r,UL center)
{
	if ( blright )
	{
		if (*rightmoveto<dst)
		{
			billiardRtoL(d,*rightmoveto,dst);
			
		}
		if (*rightmoveto<r ) (*rightmoveto)++;
	}else
	{
		if (dst<*leftmoveto)
		{
			billiardLtoR(d,dst,*leftmoveto);
		}
		if ( l<*leftmoveto ) (*leftmoveto)--;
	}
}

void splite(UL *d,UL *e,UL dst,bool blright,UL *leftmoveto,UL *rightmoveto
,UL l,UL r,UL center)
{
	if ( blright )
	{
		if (*rightmoveto<dst)
		{
			billiardRtoLe(d,e,*rightmoveto,dst);
			
		}
		if (*rightmoveto<r ) (*rightmoveto)++;
	}else
	{
		if (dst<*leftmoveto)
		{
			billiardLtoRe(d,e,dst,*leftmoveto);
		}
		if ( l<*leftmoveto ) (*leftmoveto)--;
	}
}

void replacesort(UL *d,UL l,UL r)
{
	UL i;
	UL center;
	UL dst;
	UL width=1;
	long int sign=-1;
	UL sortedl;
	UL sortedr;
	UL pivotdata;
	bool blright;
	UL leftmoveto,rightmoveto,t;
	UL seekcount;
	UL leftback,rightback;
	UL leftbigcount,rightsmallcount;
	
	UL swapwidth,swapl,swapr,swapcount;
	UL swapin,swapout,swaprejest;
	UL swapoutstart;
	UL leftlimit;
	bool returnback;

	if (l>=r)
	{
		return;
	}


	width=1;
	sign=-1;
	sortedl=1;//l.łɏς
	sortedr=1;//r.łɏς
	center=(double)(r-l)/2+0.5;
	center+=l;
	seekcount=(r-l);
	pivotdata=d[center];
	leftback=pivotdata;
	rightback=pivotdata;
	blright=false;
	leftmoveto=center-1;rightmoveto=center+1;
	leftbigcount=0;rightsmallcount=0;


	while ( 1 )//
	{
		dst=center+(sign*width);
		
		// > > 
		// < < ~
		
		if (sign==-1)
		{
			if ( sortedl )
			{
				if ( d[dst]>leftback )//here
				{
					sortedl=0;//
				}
			}
			leftback=d[dst];
		}else
		{
			if ( sortedr )
			{
				if ( rightback>d[dst] )//here
				{
					sortedr=0;//
				}
			}
			rightback=d[dst];
		}

		// <  > ~
		
		if ( blright==(d[dst]<pivotdata) && (d[dst]!=pivotdata) )//here
		{
			if ( sign<0 )
			{
				leftbigcount++;
			}else
			{
				rightsmallcount++;
			}
			split(d,dst,blright,&leftmoveto,&rightmoveto,l,r,center);
		}

		sign*=-1;
		blright=!blright;
		if ( sign<0 ) width++;
		seekcount--;
		if ( seekcount==0 ) break;
		
	}
		
	// ̑傫f[^ƉȄf[^ւ
	if ( leftbigcount==rightsmallcount && leftbigcount>0 )
	{
		swapcount=0;
		swapl=center-leftbigcount;
		swapr=center+1;
		while ( 1 )
		{
			swap(&d[swapl],&d[swapr]);
//			swap(&e[swapl],&e[swapr]);
			
			swapl++;swapr++;
			swapcount++;
			if ( swapcount==leftbigcount ) break;
		}
	}else if ( leftbigcount>0 && rightsmallcount>0 )
	{
		returnback=false;
		swapwidth=leftbigcount+rightsmallcount+1;
		swaprejest=(center-leftbigcount);
		swapout=swaprejest;
		swapin=leftbigcount+1+swaprejest;
		t=d[swapout];//te=e[swapout];
		swapcount=0;
		swapoutstart=swapout;
		leftlimit=swaprejest+rightsmallcount;

		for(i=0;i<swapwidth;i++)
		{
			d[swapout]=d[swapin];
//			e[swapout]=e[swapin];
			if (returnback)
			{
				d[swapout]=t;
//				e[swapout]=te;
				returnback=false;
				t=d[swapin];//te=e[swapin];
			}
			swapout=swapin;
			
			if (swapin>leftlimit)
			{
				swapin=swapout-(rightsmallcount+1);
				
			}else if (swapin<leftlimit)
			{
				swapin=swapout+(leftbigcount+1);
				
			}else
			{
				swapin=leftbigcount+swaprejest;
			}
			if ( i>0 && i<swapwidth-1 && swapoutstart==swapin )
			{
				swapoutstart++;
				returnback=true;
				swapin=swapoutstart;
			}
		}
	}else if ( leftbigcount>0 )
	{
		billiardRtoL(d,center-leftbigcount,center);
	}else if ( rightsmallcount>0 )
	{
		billiardLtoR(d,center,center+rightsmallcount);
	}
	
	
	if ( leftbigcount>rightsmallcount )
	{
		center-=(leftbigcount-rightsmallcount);
	}else
	{
		center+=(rightsmallcount-leftbigcount);
		
	}
		
	if ( sortedl && sortedr )
	{
		return;
	}else
	{
		if ( l<(center-1) && (center>0) && (l!=center-1) )
		{
			replacesort(d,l,center-1);
		}
		if ( (center+1<r) && (center+1!=r) )
		{
			replacesort(d,center+1,r);
		}
		
	}
}


void replacesorte(UL *d,UL *e,UL l,UL r)
{
	UL i;
	UL center;
	UL dst;
	UL width=1;
	long int sign=-1;
	UL sortedl;
	UL sortedr;
	UL pivotdata;
	bool blright;
	UL leftmoveto,rightmoveto,t,te;
	UL seekcount;
	UL leftback,rightback;
	UL leftbigcount,rightsmallcount;
	
	UL swapwidth,swapl,swapr,swapcount;
	UL swapin,swapout,swaprejest;
	UL swapoutstart;
	UL leftlimit;
	bool returnback;

	if (l>=r)
	{
		return;
	}


	width=1;
	sign=-1;
	sortedl=1;//l.łɏς
	sortedr=1;//r.łɏς
	center=(double)(r-l)/2+0.5;
	center+=l;
	seekcount=(r-l);
	pivotdata=d[center];
	leftback=pivotdata;
	rightback=pivotdata;
	blright=false;
	leftmoveto=center-1;rightmoveto=center+1;
	leftbigcount=0;rightsmallcount=0;


	while ( 1 )//
	{
		dst=center+(sign*width);
		
		// > > 
		// < < ~
		
		if (sign==-1)
		{
			if ( sortedl )
			{
				if ( d[dst]>leftback )//here
				{
					sortedl=0;//
				}
			}
			leftback=d[dst];
		}else
		{
			if ( sortedr )
			{
				if ( rightback>d[dst] )//here
				{
					sortedr=0;//
				}
			}
			rightback=d[dst];
		}

		// <  > ~
		
		if ( blright==(d[dst]<pivotdata) && (d[dst]!=pivotdata) )//here
		{
			if ( sign<0 )
			{
				leftbigcount++;
			}else
			{
				rightsmallcount++;
			}
			splite(d,e,dst,blright,&leftmoveto,&rightmoveto,l,r,center);
		}

		sign*=-1;
		blright=!blright;
		if ( sign<0 ) width++;
		seekcount--;
		if ( seekcount==0 ) break;
		
	}
		
	// ̑傫f[^ƉȄf[^ւ
	if ( leftbigcount==rightsmallcount && leftbigcount>0 )
	{
		swapcount=0;
		swapl=center-leftbigcount;
		swapr=center+1;
		while ( 1 )
		{
			swap(&d[swapl],&d[swapr]);
			swap(&e[swapl],&e[swapr]);
			
			swapl++;swapr++;
			swapcount++;
			if ( swapcount==leftbigcount ) break;
		}
	}else if ( leftbigcount>0 && rightsmallcount>0 )
	{
		returnback=false;
		swapwidth=leftbigcount+rightsmallcount+1;
		swaprejest=(center-leftbigcount);
		swapout=swaprejest;
		swapin=leftbigcount+1+swaprejest;
		t=d[swapout];te=e[swapout];
		swapcount=0;
		swapoutstart=swapout;
		leftlimit=swaprejest+rightsmallcount;

		for(i=0;i<swapwidth;i++)
		{
			d[swapout]=d[swapin];
			e[swapout]=e[swapin];
			if (returnback)
			{
				d[swapout]=t;
				e[swapout]=te;
				returnback=false;
				t=d[swapin];te=e[swapin];
			}
			swapout=swapin;
			
			if (swapin>leftlimit)
			{
				swapin=swapout-(rightsmallcount+1);
				
			}else if (swapin<leftlimit)
			{
				swapin=swapout+(leftbigcount+1);
				
			}else
			{
				swapin=leftbigcount+swaprejest;
			}
			if ( i>0 && i<swapwidth-1 && swapoutstart==swapin )
			{
				swapoutstart++;
				returnback=true;
				swapin=swapoutstart;
			}
		}
	}else if ( leftbigcount>0 )
	{
		billiardRtoLe(d,e,center-leftbigcount,center);
	}else if ( rightsmallcount>0 )
	{
		billiardLtoRe(d,e,center,center+rightsmallcount);
	}
	
	
	if ( leftbigcount>rightsmallcount )
	{
		center-=(leftbigcount-rightsmallcount);
	}else
	{
		center+=(rightsmallcount-leftbigcount);
		
	}
		
	if ( sortedl && sortedr )
	{
		return;
	}else
	{
		if ( l<(center-1) && (center>0) && (l!=center-1) )
		{
			replacesorte(d,e,l,center-1);
		}
		if ( (center+1<r) && (center+1!=r) )
		{
			replacesorte(d,e,center+1,r);
		}
		
	}
}

